qlserver 4.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170
  1. #!/bin/bash
  2. # Quake Live
  3. # Server Management Script
  4. # Author: Daniel Gibbs
  5. # Website: https://gameservermanagers.com
  6. if [ -f ".dev-debug" ]; then
  7. exec 5>dev-debug.log
  8. BASH_XTRACEFD="5"
  9. set -x
  10. fi
  11. version="160916"
  12. #### Variables ####
  13. # Notification Alerts
  14. # (on|off)
  15. # Email
  16. emailalert="off"
  17. email="email@example.com"
  18. #emailfrom="email@example.com"
  19. # Pushbullet
  20. # https://www.pushbullet.com/#settings
  21. pushbulletalert="off"
  22. pushbullettoken="accesstoken"
  23. # Steam login
  24. steamuser="anonymous"
  25. steampass=""
  26. # Start Variables
  27. arch="x64" # x64 or x86
  28. port="27960"
  29. rconport="28960"
  30. rconpassword="CHANGE_ME"
  31. statsport="${port}"
  32. statspassword="CHANGE_ME"
  33. mappool='mappool.txt'
  34. ip="0.0.0.0"
  35. updateonstart="off"
  36. # Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  37. # Console Commands : http://www.regurge.at/ql/
  38. fn_parms(){
  39. parms="+set net_strict 1 +set net_ip ${ip} +set net_port ${port} +set fs_homepath ${filesdir}/${port} +set zmq_rcon_enable 1 +set zmq_rcon_port ${rconport} +set zmq_rcon_password ${rconpassword} +set zmq_stats_enable 1 +set zmq_stats_password ${statspassword} +set zmq_stats_port ${statsport} +set sv_mapPoolFile ${mappool} +exec ${servercfg}"
  40. }
  41. #### Advanced Variables ####
  42. # Github Branch Select
  43. # Allows for the use of different function files
  44. # from a different repo and/or branch.
  45. githubuser="GameServerManagers"
  46. githubrepo="LinuxGSM"
  47. githubbranch="master"
  48. # Steam
  49. appid="349090"
  50. # Steam App Branch Select
  51. # Allows to opt into the various Steam app branches. Default branch is "".
  52. # Example: "-beta beta"
  53. branch=""
  54. # Server Details
  55. servicename="ql-server"
  56. gamename="Quake Live"
  57. engine="idtech3_ql"
  58. # Directories
  59. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  60. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  61. lockselfname=".${servicename}.lock"
  62. lgsmdir="${rootdir}/lgsm"
  63. functionsdir="${lgsmdir}/functions"
  64. libdir="${lgsmdir}/lib"
  65. tmpdir="${lgsmdir}/tmp"
  66. filesdir="${rootdir}/serverfiles"
  67. systemdir="${filesdir}"
  68. executabledir="${filesdir}"
  69. executable=$([ "${arch}" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  70. servercfg="${servicename}.cfg"
  71. servercfgdefault="server.cfg"
  72. servercfgdir="${filesdir}/baseq3"
  73. servercfgfullpath="${servercfgdir}/${servercfg}"
  74. # Backup
  75. backupdays="30"
  76. backupdir="${rootdir}/backups"
  77. # Logging
  78. logdays="7"
  79. gamelogdir="${rootdir}/log/server"
  80. scriptlogdir="${rootdir}/log/script"
  81. consolelogdir="${rootdir}/log/console"
  82. consolelogging="on"
  83. gamelog="${gamelogdir}/${servicename}-game.log"
  84. scriptlog="${scriptlogdir}/${servicename}-script.log"
  85. consolelog="${consolelogdir}/${servicename}-console.log"
  86. emaillog="${scriptlogdir}/${servicename}-email.log"
  87. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%d-%m-%Y-%H-%M-%S').log"
  88. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%d-%m-%Y-%H-%M-%S').log"
  89. ##### Script #####
  90. # Do not edit
  91. # Fetches core_dl for file downloads
  92. fn_fetch_core_dl(){
  93. github_file_url_dir="lgsm/functions"
  94. github_file_url_name="${functionfile}"
  95. filedir="${functionsdir}"
  96. filename="${github_file_url_name}"
  97. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  98. # If the file is missing, then download
  99. if [ ! -f "${filedir}/${filename}" ]; then
  100. if [ ! -d "${filedir}" ]; then
  101. mkdir -p "${filedir}"
  102. fi
  103. echo -e " fetching ${filename}...\c"
  104. # Check curl exists and use available path
  105. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  106. for curlcmd in ${curlpaths}
  107. do
  108. if [ -x "${curlcmd}" ]; then
  109. break
  110. fi
  111. done
  112. # If curl exists download file
  113. if [ "$(basename ${curlcmd})" == "curl" ]; then
  114. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  115. if [ $? -ne 0 ]; then
  116. echo -e "\e[0;31mFAIL\e[0m\n"
  117. echo "${curlfetch}"
  118. echo -e "${githuburl}\n"
  119. exit 1
  120. else
  121. echo -e "\e[0;32mOK\e[0m"
  122. fi
  123. else
  124. echo -e "\e[0;31mFAIL\e[0m\n"
  125. echo "Curl is not installed!"
  126. echo -e ""
  127. exit 1
  128. fi
  129. chmod +x "${filedir}/${filename}"
  130. fi
  131. source "${filedir}/${filename}"
  132. }
  133. core_dl.sh(){
  134. # Functions are defined in core_functions.sh.
  135. functionfile="${FUNCNAME}"
  136. fn_fetch_core_dl
  137. }
  138. core_functions.sh(){
  139. # Functions are defined in core_functions.sh.
  140. functionfile="${FUNCNAME}"
  141. fn_fetch_core_dl
  142. }
  143. core_dl.sh
  144. core_functions.sh
  145. getopt=$1
  146. core_getopt.sh